#!<WEB_PERL>

#
# The variables in angle brackets are updated
# by the web-generation scripts.
#

require  "<SERVER_CGI_LIB>";
$SERVER_NAME = "<SERVER_NAME>";
$SERVER_BIN  = "<SERVER_BIN>";
$SERVER_VAR  = "<SERVER_VAR>";
$SERVER_CGIS = "<SERVER_CGIS>";
$SERVER_CGI_URL = "<SERVER_CGI_URL>";
$AdminMail = "<SERVER_ADMIN>";
$base_href = "<BASE_HREF>"; 
$base_dir = "<BASE_DIR>"; 

#
# Start outputing HTML
#

$| = 1;
print "$ENV{'SERVER_PROTOCOL'} 200 OK\n";
print "Server: $ENV{'SERVER_SOFTWARE'}\n";
print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<BODY BGCOLOR>\n";

#
# Read in cgi data
#

&ReadParse();

#
# Configuration file for solver
#

<CONFIG_FILE>

#
# cd into WEB/ and create job.received
#

chomp($tmpFile = `$SERVER_CGIS/tempfile.cgi`);
chdir("$SERVER_VAR/spool/WEB");
open(HANDLE, ">$tmpFile");
$USER = $ENV{REMOTE_HOST};
if(!(defined($USER)))
{
    $USER = $ENV{REMOTE_ADDR};
}
$USER = "WEB_USER\@".$USER;
print HANDLE "From: $USER\n\n";
print HANDLE "type <SOFTWARE_TYPE>\n";
print HANDLE "solver <SOLVER>\n";
if (length($in{"field.0"})>0) {
  $email =  $in{"field.0"}; 
  print HANDLE "forward $email\n";
}
foreach $key (keys %in) {
    $key =~ /field.(\d+)/;
    $which = $1;
    next if ($which eq "0");
    $data = $in{$key};
    $length = length($data);
    if ($length>0) {
	if (!($data =~ /\n$/)) {
	    $data .= "\n";
	}
	$configLine = $config[$which]; 
	$configLine =~ /(.*):(.*):(.*):(.*):(.*)/;
	$beginToken = $3;
	$endToken =$4;
	$typeToken=$2;
	if ($endToken =~ /^null$/i) {
	    print HANDLE "$beginToken = $data";
	} elsif ($typeToken !~/\s*(BINARY-ON|BINARY-OFF|RADIO|TEXT)\s*/i) {
	    print HANDLE $beginToken."[".$length."]\n";
            print HANDLE "$data";  
	} else {
	    print HANDLE "$beginToken\n";
	    print HANDLE "$data";
	    print HANDLE "$endToken\n";
	}			       
    }
}
close(HANDLE);
system("chmod a+r $tmpFile");

#
# Move WEB/$tmpFile to WEB/$jobFile
#

$jobFile = "websub.$tmpFile";
system("mv $tmpFile $jobFile");

#
# Tell receiver there are submissions
#

system("touch DONE.$jobFile; touch MAIL");

#
# Wait for job number in WEB/$numberFile 
#

$numberFile = "$jobFile.number";
$MAXWAIT = 60;			
$waited  = 0;
while (!-s "$numberFile") {
    sleep 1;
    $waited++;
    if($waited > $MAXWAIT) {
	unlink ("DONE.$jobFile", "$jobFile", "MAIL");
	print "<body><h3>Failure</h3>The <SERVER_NAME> Server is not acknowledging your job submission.  The <SERVER_NAME> Server may be down.  Please try back later.";
	chomp($mailer = `which sendmail`);		
	open(HANDLE, "|$mailer -oi -t");
	print HANDLE "To: $AdminMail\n";
	print HANDLE "From: <SERVER_NAME> Server <<SERVER_EMAIL>>\n";
	print HANDLE "Subject: ERROR No Response to Web Submission\n\n";
	print HANDLE "Please check the Server to see if it is overloaded or down.\n";
	close HANDLE;
	exit 1;
    }
}
chop($JOB = `cat $numberFile`);
system("/bin/rm -f $numberFile");

print "<TITLE><SERVER_NAME> Job #$JOB</TITLE>\n";

#
# Update html file with job.out until job.results is ready.
#

print "<center><b>Job #$JOB</b></center>\n";

if(open(PASS, "$SERVER_VAR/jobs/job.$JOB/job.password")) {
    chomp($passwd = <PASS>);
    close PASS;
    print "<center><b>Job password $passwd</b></center>\n";
}
print "<center>If browser stops loading without results, enter the job number and password in the form at <a href=\"$SERVER_CGI_URL/check-status.cgi?job=$JOB\&pass=$passwd\">$SERVER_CGI_URL/check-status.cgi</a>.</b></center>\n";

while (!(-f "$SERVER_VAR/jobs/job.$JOB/job.out")) {
  sleep 1;
}

$html = 0;  #Is the solver output in html format?
$hung = 0;  #If it waits too long, the web server may time out.
open(HANDLE, "$SERVER_VAR/jobs/job.$JOB/job.out");
do {
  
  $numRead = read (HANDLE, $buffer, 1024);
  if(!(defined($numRead))) {
	print "Job output completed without end tag.\n";
       last;
  }
  if ($numRead > 0) {
    if($hung > 10) {
	print "\n";
    }
    $hung = 0;
    $totalBuffer .= $buffer; 
    if ($buffer =~ /((\S|\s)*)<CLEAR_SCREEN>((\S|\s)*)/) {
	$buffer = $1.$3;
    } 
    if ($buffer =~ /((\S|\s)*)<END_STANDARD_OUT>((\S|\s)*)/) {
      $buffer = $1.$3;
    } 
    
    unless($html) {
	if($totalBuffer =~/&\w+;/) {
	    $html = 1;
	} else {
	    $buffer =~ s/&/&amp;/g;
	    $buffer =~ s/</&lt;/g;
	    $buffer =~ s/>/&gt;/g;
	}
    }
    $buffer =~ s/\n/<br>\n/g;
    print $buffer;
  } else { 
    $hung++;
    if($hung > 10) {
	print ".";
	if($hung > 20) {
	    print "<br>\n";
	    $hung = 0;
	}
    }
    sleep(2);
  }
  sleep(1);
} until ($totalBuffer =~ /<END_STANDARD_OUT>/);
close HANDLE;
$totalBuffer = "";

#
# Job results.
#

open(WEB, "><BASE_DIR>/jobs/$JOB.html.tmp") or print "Could not write results page.\n";
print WEB "<title><SERVER_NAME> Job #$JOB</title>\n"; 
print WEB "<BODY BGCOLOR>\n";
print WEB "<center>\n";
print WEB "<a href = \"<BASE_HREF>\"><img src=\"<BASE_HREF>/images/globe_small.jpg\" alt=\"NEOS Server Home\" border=0></a>";
print WEB "</center>\n";
print WEB "<PRE>\n";
$RESULTS = `cat $SERVER_VAR/jobs/job.$JOB/job.results`;
unless($RESULTS =~ /&\w+;/) {
     $RESULTS =~ s/&/&amp;/g;
     $RESULTS =~ s/</&lt;/g;
     $RESULTS =~ s/>/&gt;/g;
}
print WEB "$RESULTS\n";
print WEB "</PRE>\n";
print WEB "<P><hr>\n";
print WEB "<center>\n";
print WEB "<a href = \"<BASE_HREF>\" ><img src=\"<BASE_HREF>/images/neos_home.jpg\" border=0 alt=\"<SERVER_NAME> Server\"></a>";
print WEB "</center>\n</BODY>";
close(WEB);
rename "<BASE_DIR>/jobs/$JOB.html.tmp", "<BASE_DIR>/jobs/$JOB.html";
unlink "$SERVER_VAR/tmp/WEB_READING_JOB.$JOB";

#refresh to results page
print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"3; URL=<BASE_HREF>/jobs/$JOB.html\">\n";
print "<BLINK> Keep waiting for the results. </BLINK>\n";
print "<hr><P>\n";
