$SERVER_HOME = $ENV{SERVER_HOME};
$BASE_HREF   = $ENV{SERVER_WWW_URL};
$BASE_DIR    = $ENV{SERVER_WWW_HOME};
$ENV{BACKGROUND}="BGCOLOR=\"$ENV{SERVER_WWW_BACKGROUND}\""; 
$BACKGROUND  = $ENV{BACKGROUND};
$SERVER_NAME = $ENV{SERVER_NAME};


#
# Read in solver list and generate list
#

$TEXT = `cat  $ENV{SERVER_LIB}/html/server-solvers-in_1.html`;
$TEXT =~ s/<BASE_HREF>/$BASE_HREF\//g;
$TEXT =~ s/<SERVER_NAME>/$SERVER_NAME/g;
$TEXT =~ s/<BACKGROUND_COLOR>/$BACKGROUND/g;
print $TEXT;

chomp(@TREE = `cat $ENV{SERVER_VAR}/lib/input_tree`); 
chomp(@TREE = (@TREE, `cat $ENV{SERVER_LIB}/admin_tree`));
chomp(@PACKAGES = `cat $ENV{SERVER_VAR}/lib/solver_list`);

chomp(@PROBLEMS = `cat $ENV{SERVER_VAR}/lib/solver_tree`);
chomp(@ADPACKAGES = (`cat $ENV{SERVER_LIB}/admin_list`));

foreach $asolver (@ADPACKAGES) {
    $asolver =~ /(.*)=(.*)\s*$/;
    $token = $2;
    $TITLE{"$token"} = $1;
    $token =~ /(.*):(.+)/;
    $type = $1;
    $similar = $accepts{"$type"};
    $similar = "$similar<BREAK>$token";
    $accepts{"$type"} = $similar;
}

foreach $type (@PROBLEMS) {
    $type =~ /(.*)=(.*)\s*$/;
    $token = "\U$2";
    $TITLE{"$token"} = $1;
}

#
#
# Hash the solvers' inputs.
#

foreach $solver (@PACKAGES) {
    if($solver =~ /=KESTREL_/ or $solver =~ /^\s*$/) {
	next;
    }
    $solver =~ /(.*)=(.*)\s*$/;
    $token = $2;
    $TITLE{"$token"} = $1;
    if(open(IN,"$ENV{SERVER_VAR}/lib/solvers/$token/ACCEPTS")) {
	$takes = <IN>;
	close IN;
	if($takes =~ /^\s*$/) {
	    $similar = $accepts{"OTHER"};
	    $similar = "$similar<BREAK>$token";
	    $accepts{"OTHER"} = $similar;
	}
	while($takes =~ /^((\S*?)<ACCEPTS>)/) {
	    $crop = $1;
	    $input = "\U$2";
	    $similar = $accepts{"$input"};
	    $similar = "$similar<BREAK>$token";
	    $accepts{"$input"} = $similar;
	    $takes =~ s#^$crop##;
	}
    } else {
	$similar = $accepts{"OTHER"};
	$similar = "$similar<BREAK>$token";
	$accepts{"OTHER"} = $similar;
    }			      
}

#
# Make an associative array using the software's token
# as the key containing the software's "TYPE"
# 

foreach $type (@TREE) {		
    $type =~ s/\s$//;		 
    if($type =~ /=kestrel_/i or $type =~ /^\s*$/) {
	next;
    }
    $type =~ /(.+)=(.+)/;
    $type = "\U$2";
    @subtypes = split(/\:/, $type);
    $length = @subtypes;
    for($i=0;$i<$length;$i++) {
	print "<UL>\n";
    }
    print "<LI><b>$1</b>\n";
    for($i=0;$i<$length;$i++) {
	print "</UL>\n";
    }
    for($i=0;$i<$length;$i++) {
	print "<UL>\n";
    }
    $solvers = $accepts{"$type"};
    @solvers = split '<BREAK>', $solvers;
    @solvers = sort(@solvers);
    $PREVTYPE = "";
    print "<UL>\n";
    foreach $TOKEN (@solvers) {
	if($TOKEN =~ /^\s*$/) { next; }
	$TOKEN =~ s/\s$//;
	$TITLE = $TITLE{"$TOKEN"};
	$TOKEN =~ /(.*):(.+)/;
	$TYPE = $1;
	if(!($TYPE eq $PREVTYPE)) {
	    $DESCR = $TITLE{"$TYPE"};
	#    print "</UL>\n";
	    if($PREVTYPE =~ /\S/) {
		print "<br>\n";
	    }
	    if(defined($DESCR)) {
		print "</UL><UL><LI><b>$DESCR</b><br>\n";
	    }
	    $PREVTYPE = $TYPE;
	}
	print "     <A HREF=\"$BASE_HREF/solvers/$TOKEN\"><b>$TITLE</b></A><br>\n";
      
    }
    for($i=0;$i<=$length;$i++) {
	print "</UL>\n";
    }
}				# 

print "<UL>\n";
$TEXT = `cat $ENV{SERVER_LIB}/html/server-solvers_2.html`;
$TEXT =~ s/<SERVER_NAME>/$SERVER_NAME/g;
$TEXT =~ s/<BASE_HREF>/$BASE_HREF\//g;
print $TEXT;




